import { Component } from '@angular/core';
import { Image, ImagesService } from '../services/images.service';
import { ActivatedRoute, Router } from '@angular/router';
import { UsersService } from '../services/users.service';
import { ScrollService } from '../services/scroll.service';
import { MessagesService } from '../services/messages.service';
import { environment } from 'src/environments/environment';

@Component({
  selector: 'app-page-image',
  templateUrl: './page-image.component.html',
  styleUrls: ['./page-image.component.scss']
})
export class PageImageComponent {
    public image?: Image | null;
    public environment = environment;

    public async like() {
        try {
            this.image = await this.images.like(this.image!.id);
        }
        catch (e: any) { this.msgs.error(e); }
    }
    public async unlike() {
        try {
            this.image = await this.images.unlike(this.image!.id);
        }
        catch (e: any) { this.msgs.error(e); }
    }
    public async delete() {
        try {
            await this.images.delete(this.image!.id);
            this.router.navigateByUrl('/');
        }
        catch (e: any) { this.msgs.error(e); }
    }

    public constructor(
        route: ActivatedRoute,
        public users: UsersService,
        private images: ImagesService,
        private msgs: MessagesService,
        private router: Router,
    ) {
        route.paramMap.subscribe(async v => {
            try {
                this.image = await images.get(v.get('id')!);
            }
            catch (e: any) { msgs.error(e); }
            // this.imagesEl.next();
        });
    }
}
