import { Component } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { UsersService } from '../services/users.service';
import { Router } from '@angular/router';
import { MessagesService } from '../services/messages.service';

@Component({
  selector: 'app-page-signup',
  templateUrl: './page-signup.component.html',
  styleUrls: ['./page-signup.component.scss']
})
export class PageSignupComponent {
    public form = new FormGroup({
        username: new FormControl<string>(''),
        password: new FormControl<string>(''),
    });

    public async signup() {
        try {
            await this.users.signup(
                this.form.value.username ?? '',
                this.form.value.password ?? ''
            );
            this.router.navigateByUrl('/');
        }
        catch (e: any) { this.msgs.error(e); }
    }

    public constructor(
        private msgs: MessagesService,
        private users: UsersService,
        private router: Router
    ) { }
}
