import { HttpClient } from '@angular/common/http';
import { Pipe, PipeTransform } from '@angular/core';
import { DomSanitizer, SafeUrl } from '@angular/platform-browser';
import { Observable, firstValueFrom } from 'rxjs';

@Pipe({
    name: 'secure'
})
export class SecurePipe implements PipeTransform {
    constructor(private http: HttpClient, private sanitizer: DomSanitizer) { }

    public async transform(url: string): Promise<SafeUrl> {
        const res = await firstValueFrom(this.http.get(url, { responseType: 'blob' }));
        return this.sanitizer.bypassSecurityTrustUrl(URL.createObjectURL(res));
    }

}
